Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Component_generate_file.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Component_generate_file.cpp	(revision 42)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Component_generate_file.cpp	(revision 42)
@@ -0,0 +1,33 @@
+#ifdef POSITION
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/include/Component.h"
+
+namespace morpheo              {
+namespace behavioural          {
+
+  void Component::generate_file (void)
+  {
+    try 
+      {
+	XML xml = toXML();
+
+	xml.filename_extension ("pos");
+	
+	xml.generate_file("ISO-8859-1");
+
+      }
+    catch (ErrorMorpheo e)
+      {
+	throw (ErrorMorpheo ("Component \""+_entity->get_name()+"\" have a bad mapping : "+e.what()));
+      }
+  };
+
+}; // end namespace behavioural          
+}; // end namespace morpheo              
+#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Component_get_component.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Component_get_component.cpp	(revision 42)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Component_get_component.cpp	(revision 42)
@@ -0,0 +1,49 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/include/Component.h"
+
+namespace morpheo              {
+namespace behavioural          {
+
+  string Component::get_component (void)
+  {
+    uint32_t               depth          = 0;
+    string                 separator      = "\n";
+    bool                   last_separator = false;
+
+    list<Entity *>::iterator  i  = _list_component->begin();
+    bool                   empty = _list_component->empty();
+
+    string                 tab   = string(depth,'\t');
+    ostringstream          text;
+
+    if (not empty)
+      {
+	// First
+	if (i != _list_component->end())
+	  {
+	    text << tab << **i;
+	    ++i;
+	  }
+	
+	while (i != _list_component->end())
+	  {
+	    text << separator;
+	    text << tab << **i;
+	    ++i;
+	  }
+	
+	if (last_separator)
+	  text << separator;
+      }
+
+    return text.str();
+  };
+
+}; // end namespace behavioural          
+}; // end namespace morpheo              
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Component_get_entity.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Component_get_entity.cpp	(revision 42)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Component_get_entity.cpp	(revision 42)
@@ -0,0 +1,21 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/include/Component.h"
+
+namespace morpheo              {
+namespace behavioural          {
+
+  string Component::get_entity (void)
+  {
+    ostringstream text;
+    text << *(_entity); 
+    return text.str();
+  };
+
+}; // end namespace behavioural          
+}; // end namespace morpheo              
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Component_interface_map.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Component_interface_map.cpp	(revision 42)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Component_interface_map.cpp	(revision 42)
@@ -0,0 +1,60 @@
+#ifdef POSITION
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/include/Component.h"
+
+namespace morpheo              {
+namespace behavioural          {
+
+  void Component::interface_map (string component_src ,
+				 string port_src      ,
+				 string component_dest,
+				 string port_dest     )
+  {
+    // First entity 
+    Entity * entity_dest = find_entity(component_dest);
+
+    string name_entity = _entity->get_name();
+
+    if (entity_dest == NULL)
+      throw (ErrorMorpheo ("Component \""+name_entity+"\", port map with unknow component \""+component_dest+"\"."));
+
+    bool is_top_level_dest = (name_entity == component_dest);
+
+    Interface * interface_dest = entity_dest->find_interface(port_dest);
+    
+    if (interface_dest == NULL)
+      throw (ErrorMorpheo ("Component \""+name_entity+"\", port map with component \""+component_dest+"\" and a unknow interface \""+port_dest+"\"."));
+
+    // Second entity
+    Entity * entity_src = find_entity(component_src);
+
+    if (entity_src == NULL)
+      throw (ErrorMorpheo ("Component \""+name_entity+"\", port map with unknow component \""+component_src+"\"."));
+
+    bool is_top_level_src = (name_entity == component_src);
+
+    Interface * interface_src = entity_src->find_interface(port_src);
+
+    if (interface_src == NULL)
+      throw (ErrorMorpheo ("Component \""+name_entity+"\", port map with component \""+component_src+"\" and a unknow interface \""+port_src+"\"."));
+
+    // all is ok - link
+    if (is_top_level_dest == false)
+      interface_dest->interface_map(static_cast<void *>(entity_src   ),
+				    static_cast<void *>(interface_src));
+    
+    if (is_top_level_src == false)
+      interface_src->interface_map(static_cast<void *>(entity_dest   ),
+				   static_cast<void *>(interface_dest));
+    
+  };
+
+}; // end namespace behavioural          
+}; // end namespace morpheo              
+#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Component_port_map.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Component_port_map.cpp	(revision 42)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Component_port_map.cpp	(revision 42)
@@ -0,0 +1,48 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/include/Component.h"
+
+namespace morpheo              {
+namespace behavioural          {
+
+  void Component::port_map (string component_src ,
+			    string port_src      ,
+			    string component_dest,
+			    string port_dest     )
+  {
+    string name_entity = _entity->get_name();
+
+    // First entity 
+    Entity * entity_dest = find_entity(component_dest);
+
+    if (entity_dest == NULL)
+      throw (ErrorMorpheo ("Component \""+name_entity+"\", port map with unknow component \""+component_dest+"\"."));
+
+    Signal * signal_dest = entity_dest->find_signal (port_dest);
+
+    if (signal_dest == NULL)
+      throw (ErrorMorpheo ("Component \""+name_entity+"\", port map with component \""+component_dest+"\" and a unknow signal \""+port_dest+"\"."));
+
+    // Second entity
+    Entity * entity_src = find_entity(component_src);
+
+    if (entity_src == NULL)
+      throw (ErrorMorpheo ("Component \""+name_entity+"\", port map with unknow component \""+component_src+"\"."));
+
+    Signal * signal_src = entity_src->find_signal (port_src);
+
+    if (signal_src == NULL)
+      throw (ErrorMorpheo ("Component \""+name_entity+"\", port map with component \""+component_src+"\" and a unknow signal \""+port_src+"\"."));
+
+    // If all is ok, mapping
+    signal_src ->link   (signal_dest);
+    signal_dest->mapping(signal_src );
+  };
+
+}; // end namespace behavioural          
+}; // end namespace morpheo              
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Component_print.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Component_print.cpp	(revision 42)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Component_print.cpp	(revision 42)
@@ -0,0 +1,23 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/include/Component.h"
+
+
+namespace morpheo              {
+namespace behavioural          {
+
+  ostream& operator<< (ostream& output_stream,
+		       morpheo::behavioural::Component & x)
+  {
+    output_stream << x.get_entity    () << endl;
+    output_stream << x.get_component () << endl;
+    return output_stream;
+  };
+  
+}; // end namespace behavioural          
+}; // end namespace morpheo              
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Component_set_component.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Component_set_component.cpp	(revision 42)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Component_set_component.cpp	(revision 42)
@@ -0,0 +1,32 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/include/Component.h"
+
+namespace morpheo              {
+namespace behavioural          {
+
+  void Component::set_component (Component * component
+#ifdef POSITION
+				,uint32_t   pos_x  
+				,uint32_t   pos_y  
+				,uint32_t   size_x 
+				,uint32_t   size_y 
+#endif
+				 )
+  {
+    Entity * entity = component->_entity;
+
+    _list_component->push_back(entity);
+
+#ifdef POSITION
+    entity->mapping( pos_x, pos_y, size_x, size_y);
+#endif
+  };
+
+}; // end namespace behavioural          
+}; // end namespace morpheo              
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Component_set_entity.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Component_set_entity.cpp	(revision 42)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Component_set_entity.cpp	(revision 42)
@@ -0,0 +1,32 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/include/Component.h"
+
+namespace morpheo              {
+namespace behavioural          {
+
+  Entity * Component::set_entity (string        name   
+				  ,string        type   
+#ifdef POSITION
+				  ,schema_t      schema
+#endif
+				  )
+  {
+    Entity * entity = new Entity (name   
+				  ,type   
+#ifdef POSITION
+				  ,schema 
+#endif
+				  );
+    _entity = entity;
+    
+    return entity;
+  };
+
+}; // end namespace behavioural          
+}; // end namespace morpheo              
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Component_toXML.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Component_toXML.cpp	(revision 42)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Component_toXML.cpp	(revision 42)
@@ -0,0 +1,41 @@
+#ifdef POSITION
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/include/Component.h"
+
+namespace morpheo              {
+namespace behavioural          {
+
+  XML Component::toXML (void)
+  {
+    XML xml (_entity->get_name());
+    
+    xml.balise_open         ("description");
+    xml.  insert_XML        (_entity->toXML());
+    xml.  balise_open       ("architecture");
+
+    if (_list_component->empty()== false)
+      {
+	list<Entity *>::iterator i = _list_component->begin();
+
+	while (i != _list_component->end())
+	  {
+	    xml.insert_XML ((*i)->toXML_mapping());
+	    ++i;
+	  }
+      }
+	
+    xml.  balise_close      ();
+    xml.balise_close        ();
+    
+    return xml;
+  };
+
+}; // end namespace behavioural          
+}; // end namespace morpheo              
+#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Component_vhdl_instance.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Component_vhdl_instance.cpp	(revision 42)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Component_vhdl_instance.cpp	(revision 42)
@@ -0,0 +1,91 @@
+#ifdef VHDL
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/include/Component.h"
+
+namespace morpheo              {
+namespace behavioural          {
+
+  void Component::vhdl_instance (Vhdl * & vhdl)
+  {
+    uint32_t             cpt = 0;
+    map<Signal *,string> tab;
+
+    vhdl->set_library_work (_entity->get_name() + "_Pack");
+
+    // for each entity
+    list<Entity *>         * list_component = _list_component;
+    list<Entity *>::iterator i              = list_component->begin();
+    if (not list_component->empty())
+      {
+	while (i != list_component->end())
+	  {
+	    vhdl->set_library_work ((*i)->get_name() + "_Pack");
+
+	    list<string> list_port_map;
+	    
+	    // for each interface
+	    list<Interface_fifo *>         * list_interface = (*i)->get_interfaces_list()->get_interface_list();
+	    list<Interface_fifo *>::iterator j              = list_interface->begin();
+	    if (not list_interface->empty())
+	      {
+		while (j != list_interface->end())
+		  {
+		    // for each signal
+		    list<Signal *>         * list_signal = (*j)->get_signal_list();
+		    list<Signal *>::iterator k           = list_signal->begin();
+		    if (not list_signal->empty())
+		      {
+			while (k != list_signal->end())
+			  {
+			    // test if is connect with external interface or with an another component.
+			    Signal * signal_src  = (*k);
+			    if (signal_src->presence_vhdl () == true)
+			      {
+				Signal * signal_dest = (*k)->get_signal_link();
+				string   name_src    = signal_src->get_name();
+				string   name_dest;
+				
+				if (_entity->find_signal(signal_dest) == false)
+				  {
+				    // find if signal is already link
+				    map<Signal *,string>::iterator it = tab.find(signal_src); 
+				    if (tab.find(signal_src) == tab.end())
+				      {
+					// Create name
+					name_dest = "signal_"+toString(cpt++);
+					
+					tab [signal_src ] = name_dest;
+					tab [signal_dest] = name_dest;
+					
+					// Add a new signal
+					vhdl->set_signal (name_dest, signal_src->get_size());
+				      }
+				    else
+				      name_dest = (*it).second;
+				  }
+				else
+				  name_dest = signal_dest->get_name();
+				
+				vhdl->set_body_component_port_map (list_port_map, name_src, name_dest);
+			      }
+			    ++k;
+			  }
+		      }
+		    ++j;
+		  }
+	      }
+	    vhdl->set_body_component ("instance_"+(*i)->get_name(),(*i)->get_name(),list_port_map);
+	    ++i;
+	  }
+      }
+  };
+
+}; // end namespace behavioural
+}; // end namespace morpheo
+#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Entity.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Entity.cpp	(revision 41)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Entity.cpp	(revision 42)
@@ -1,3 +1,2 @@
-#ifdef POSITION
 /*
  * $Id$
@@ -12,26 +11,37 @@
 namespace behavioural          {
 
-  Entity::Entity  (string       name   ,
-		   string       type   ,
-		   schema_t     schema):
-    _name       (name      ),
-    _type       (type      ),
-    _schema     (schema    )
+  Entity::Entity  ( string       name   
+		   ,string       type  
+#ifdef POSITION
+		   ,schema_t     schema
+#endif
+		    ):
+     _name       (name      )
+    ,_type       (type      )
+#ifdef POSITION
+    ,_schema     (schema    )
+#endif
   {
     log_printf(FUNC,Behavioural,"Entity","Begin");
     _interfaces = new Interfaces (name);
+#ifdef POSITION
     _is_map     = false;
+#endif
     log_printf(FUNC,Behavioural,"Entity","End");
   };
 
   Entity::Entity  (const Entity & entity):
-    _name       (entity._name      ),
-    _type       (entity._type      ),
-    _schema     (entity._schema    )
+     _name       (entity._name      )
+    ,_type       (entity._type      )
+#ifdef POSITION
+    ,_schema     (entity._schema    )
+#endif
   {
     log_printf(FUNC,Behavioural,"Entity (copy)","Begin");
+    _interfaces = entity._interfaces;
+#ifdef POSITION
     _is_map     = entity._is_map    ;
-    _interfaces = entity._interfaces;
     _comment    = entity._comment   ;
+#endif
     log_printf(FUNC,Behavioural,"Entity (copy)","End");
   };
@@ -43,7 +53,5 @@
     log_printf(FUNC,Behavioural,"~Entity","End");
   };
-  
 
 }; // end namespace behavioural          
 }; // end namespace morpheo              
-#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Entity_find_interface.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Entity_find_interface.cpp	(revision 41)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Entity_find_interface.cpp	(revision 42)
@@ -1,3 +1,2 @@
-#ifdef POSITION
 /*
  * $Id$
@@ -19,3 +18,2 @@
 }; // end namespace behavioural          
 }; // end namespace morpheo              
-#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Entity_find_signal.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Entity_find_signal.cpp	(revision 42)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Entity_find_signal.cpp	(revision 42)
@@ -0,0 +1,24 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/include/Entity.h"
+
+namespace morpheo              {
+namespace behavioural          {
+
+  Signal * Entity::find_signal (string name)
+  {
+    return _interfaces->find_signal(name);
+  };
+
+  bool Entity::find_signal (Signal * signal)
+  {
+    return _interfaces->find_signal(signal);
+  };
+
+}; // end namespace behavioural          
+}; // end namespace morpheo              
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Entity_get_interfaces.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Entity_get_interfaces.cpp	(revision 41)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Entity_get_interfaces.cpp	(revision 42)
@@ -1,3 +1,2 @@
-#ifdef POSITION
 /*
  * $Id$
@@ -20,5 +19,10 @@
   };
 
+  Interfaces * Entity::get_interfaces_list (void)
+  {
+    return _interfaces; 
+  };
+  
+
 }; // end namespace behavioural          
 }; // end namespace morpheo              
-#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Entity_get_name.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Entity_get_name.cpp	(revision 42)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Entity_get_name.cpp	(revision 42)
@@ -0,0 +1,20 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/include/Entity.h"
+
+
+namespace morpheo              {
+namespace behavioural          {
+
+  string Entity::get_name (void)
+  {
+    return _name;
+  };
+
+}; // end namespace behavioural          
+}; // end namespace morpheo
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Entity_get_type.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Entity_get_type.cpp	(revision 42)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Entity_get_type.cpp	(revision 42)
@@ -0,0 +1,20 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/include/Entity.h"
+
+
+namespace morpheo              {
+namespace behavioural          {
+
+  string Entity::get_type (void)
+  {
+    return _type;
+  };
+
+}; // end namespace behavioural          
+}; // end namespace morpheo
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Entity_mapping.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Entity_mapping.cpp	(revision 42)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Entity_mapping.cpp	(revision 42)
@@ -0,0 +1,33 @@
+#ifdef POSITION
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/include/Entity.h"
+
+
+namespace morpheo              {
+namespace behavioural          {
+
+  void Entity::mapping (uint32_t pos_x,
+			uint32_t pos_y,
+			uint32_t size_x ,
+			uint32_t size_y )
+  {
+    if (_is_map != false)
+      throw (ErrorMorpheo ("Entity \""+_name+"\" is already mapped"));
+
+    _is_map = true;
+
+    _map_size_x = size_x;
+    _map_size_y = size_y;
+    _map_pos_x  = pos_x ;
+    _map_pos_y  = pos_y ;
+  };
+
+}; // end namespace behavioural          
+}; // end namespace morpheo              
+#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Entity_print.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Entity_print.cpp	(revision 41)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Entity_print.cpp	(revision 42)
@@ -1,3 +1,2 @@
-#ifdef POSITION
 /*
  * $Id$
@@ -16,6 +15,10 @@
 		       morpheo::behavioural::Entity & x)
   {
+#ifdef POSITION
     output_stream << x._name + "\t"+x._type+"\t"+toString(x._schema) << endl;
     output_stream << x.get_comment()    << endl;
+#else
+    output_stream << x._name + "\t"+x._type<< endl;
+#endif
     output_stream << x.get_interfaces() << endl;
     return output_stream;
@@ -24,3 +27,2 @@
 }; // end namespace behavioural          
 }; // end namespace morpheo              
-#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Entity_set_interfaces.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Entity_set_interfaces.cpp	(revision 41)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Entity_set_interfaces.cpp	(revision 42)
@@ -1,3 +1,2 @@
-#ifdef POSITION
 /*
  * $Id$
@@ -19,3 +18,2 @@
 }; // end namespace behavioural          
 }; // end namespace morpheo              
-#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interface.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interface.cpp	(revision 41)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interface.cpp	(revision 42)
@@ -11,17 +11,22 @@
 namespace behavioural          {
 
-  Interface::Interface  (string                name         ,
-			 direction_t           direction    ,
-			 localisation_t        localisation ):
-    _name         (name        ),
-    _direction    (direction   ),
-    _localisation (localisation)
+  Interface::Interface  (string                name         
+#ifdef POSITION
+			 ,direction_t           direction    
+			 ,localisation_t        localisation 
+#endif
+			 ):
+    _name         (name        )
+#ifdef POSITION
+    ,_direction    (direction   )
+    ,_localisation (localisation)
+#endif
   {
     log_printf(FUNC,Behavioural,"Interface","Begin");
 
-    _comment       = "";
     _list_signal   = new (list<Signal*>);
 
 #ifdef POSITION
+    _comment       = "";
     _is_map        = false;
     _entity_map    = NULL;
@@ -37,12 +42,14 @@
 
   Interface::Interface  (const Interface & interface):
-    _name         (interface._name        ),
-    _direction    (interface._direction   ),
-    _localisation (interface._localisation)
+    _name         (interface._name        )
+#ifdef POSITION
+    ,_direction    (interface._direction   )
+    ,_localisation (interface._localisation)
+#endif
   {
     log_printf(FUNC,Behavioural,"Interface (copy)","Begin");
-    _comment       = interface._comment    ;
     _list_signal   = interface._list_signal;
 #ifdef POSITION
+    _comment       = interface._comment    ;
     _is_map        = interface._is_map     ;
     _entity_map    = interface._entity_map   ;
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interface_fifo.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interface_fifo.cpp	(revision 41)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interface_fifo.cpp	(revision 42)
@@ -11,10 +11,16 @@
 namespace behavioural          {
 
-  Interface_fifo::Interface_fifo  (string         name        ,
-				   direction_t    direction   ,
-				   localisation_t localisation):
-    Interface (name        , 
-	       direction   ,
-	       localisation)
+  Interface_fifo::Interface_fifo  (string         name        
+#ifdef POSITION
+				   ,direction_t    direction   
+				   ,localisation_t localisation
+#endif
+				   ):
+    Interface (name         
+#ifdef POSITION
+	       ,direction   
+	       ,localisation
+#endif
+	       )
   {
     log_printf(FUNC,Behavioural,"Interface_fifo","Begin");
@@ -32,7 +38,10 @@
 
   Interface_fifo::Interface_fifo  (const Interface_fifo & interface_fifo) :
-    Interface (interface_fifo._name        , 
-	       interface_fifo._direction   ,
-	       interface_fifo._localisation)
+    Interface (interface_fifo._name         
+#ifdef POSITION
+	       ,interface_fifo._direction   
+	       ,interface_fifo._localisation
+#endif
+	       )
   {
     log_printf(FUNC,Behavioural,"Interface_fifo (copy)","Begin");
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interface_fifo_get_cycle.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interface_fifo_get_cycle.cpp	(revision 41)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interface_fifo_get_cycle.cpp	(revision 42)
@@ -17,6 +17,9 @@
     if (_test_exhaustive == true)
       return Interface::get_cycle();
-    
-    return _list_cycle->back();
+
+    if (_list_cycle->empty() == true)
+      return 0;
+    else
+      return _list_cycle->back();
   };
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interface_fifo_testbench_test.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interface_fifo_testbench_test.cpp	(revision 41)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interface_fifo_testbench_test.cpp	(revision 42)
@@ -13,5 +13,6 @@
 
   string Interface_fifo::testbench_test (Vhdl * & vhdl,
-				       string   counter_name)
+					 string   counter_name,
+					 string   reset_name  )
   {
     log_printf(FUNC,Behavioural,"testbench_test","Begin");
@@ -19,5 +20,5 @@
     
     if (_test_exhaustive == true)
-      test_name = Interface::testbench_test(vhdl,counter_name);
+      test_name = Interface::testbench_test(vhdl,counter_name,reset_name);
     else
       {
@@ -26,11 +27,15 @@
 	vhdl->set_body("");
 
-	test_name    = testbench_test_name   (vhdl);
-	string test_name_ok = testbench_test_ok     (vhdl);
+	       test_name        = testbench_test_name        (vhdl);
+	string test_name_tmp    = test_name+"_tmp";
+	string test_name_ok     = testbench_test_ok          (vhdl);
+ 	string test_transaction = testbench_test_transaction (vhdl);
+
+	vhdl->set_signal(test_name_tmp,1);
 
 	if (_list_cycle->empty()== false)
 	  {
 	    vhdl->set_body ("with "+counter_name+" select");
-	    vhdl->set_body ("\t"+test_name+" <=");
+	    vhdl->set_body ("\t"+test_name_tmp+" <=");
 	
 	    list<uint32_t>::iterator i = _list_cycle->begin();
@@ -38,9 +43,35 @@
 	    while (i != _list_cycle->end())
 	      {
-		vhdl->set_body ("\t"+test_name_ok+" when "+toString(*i)+",");
+		vhdl->set_body ("\t"+test_transaction+" and "+test_name_ok+" when "+toString(*i)+",");
 		++i;
 	      }
-	    vhdl->set_body ("\t'1' when others;");
+	    vhdl->set_body ("\tnot "+test_transaction+" when others;");
 	  }
+	else
+	  vhdl->set_body (test_name_tmp+" <= not "+test_transaction+";");
+	
+	vhdl->set_body("");
+	vhdl->set_body(test_name + " <= '1' when ("+reset_name+" = '0') else "+test_name_tmp+";");
+
+#ifdef VHDL_TESTBENCH_ASSERT
+	if (_list_cycle->empty()== false)
+	  {
+	    vhdl->set_body("");
+	    vhdl->set_body("-- Assert ...");
+	    vhdl->set_body("");
+
+	    uint32_t                 j = 0;
+	    list<uint32_t>::iterator i = _list_cycle->begin();
+	    
+	    while (i != _list_cycle->end())
+	      {
+		vhdl->set_body("assert not ( ("+counter_name+" = "+toString(*i)+")) report \"***** <"+_name+"> interface's test number "+toString(j)+" *****\" severity NOTE;");
+		j++;
+		++i;
+	      }
+
+	    vhdl->set_body("");
+	  }
+#endif
       }
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interface_fifo_testbench_test_transaction.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interface_fifo_testbench_test_transaction.cpp	(revision 42)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interface_fifo_testbench_test_transaction.cpp	(revision 42)
@@ -0,0 +1,56 @@
+#ifdef VHDL_TESTBENCH
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/include/Interface_fifo.h"
+
+namespace morpheo              {
+namespace behavioural          {
+
+  string Interface_fifo::testbench_test_transaction (Vhdl * & vhdl)
+  {
+    log_printf(FUNC,Behavioural,"testbench_test_transaction","Begin");
+    
+    string name = testbench_test_transaction_name(vhdl);
+
+    vhdl->set_body(name+" <= '1'");
+
+    // list "val"
+    if (_list_signal_val->empty()== false)
+      {
+	list<Signal*>::iterator i = _list_signal_val->begin();
+
+	while (i != _list_signal_val->end())
+	  {
+	    vhdl->set_body("\tand "+(*i)->get_name());
+	    ++i;
+	  }
+      }
+
+    // list "ack"
+    if (_list_signal_ack->empty()== false)
+      {
+	list<Signal*>::iterator i = _list_signal_ack->begin();
+
+	while (i != _list_signal_ack->end())
+	  {
+	    vhdl->set_body("\tand "+(*i)->get_name());
+	    ++i;
+	  }
+      }
+
+    vhdl->set_body("\t;");
+    vhdl->set_body("");
+
+    log_printf(FUNC,Behavioural,"testbench_test_transaction","End");
+
+    return name;
+  };
+
+}; // end namespace behavioural          
+}; // end namespace morpheo              
+#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interface_fifo_testbench_transaction.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interface_fifo_testbench_transaction.cpp	(revision 41)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interface_fifo_testbench_transaction.cpp	(revision 42)
@@ -1,2 +1,3 @@
+#ifdef VHDL_TESTBENCH
 /*
  * $Id$
@@ -48,2 +49,3 @@
 }; // end namespace behavioural          
 }; // end namespace morpheo              
+#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interface_find_signal.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interface_find_signal.cpp	(revision 42)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interface_find_signal.cpp	(revision 42)
@@ -0,0 +1,63 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/include/Interface.h"
+
+
+namespace morpheo              {
+namespace behavioural          {
+
+  Signal * Interface::find_signal (string name)
+  {
+    log_printf(FUNC,Behavioural,"find_signal","Begin");
+
+    list<Signal*>::iterator i   = _list_signal->begin();
+    Signal *                sig = NULL;
+    if (_list_signal->empty() == false)
+      {
+	while (i != _list_signal->end())
+	  {
+	    if ((*i)->get_name() == name)
+	      {
+		sig = (*i);
+		break;
+	      }
+	    ++i;
+	  }
+      }
+
+    log_printf(FUNC,Behavioural,"find_signal","End");
+
+    return sig;
+  };
+
+  bool Interface::find_signal (Signal * signal)
+  {
+    log_printf(FUNC,Behavioural,"find_signal","Begin");
+
+    bool find = false;
+    list<Signal*>::iterator i = _list_signal->begin();
+    if (_list_signal->empty() == false)
+      {
+	while (i != _list_signal->end())
+	  {
+	    if ( (*i) == signal)
+	      {
+		find = true;
+		break;
+	      }
+	    ++i;
+	  }
+      }
+
+    log_printf(FUNC,Behavioural,"find_signal","End");
+
+    return find;
+  };
+
+}; // end namespace behavioural          
+}; // end namespace morpheo              
